#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/wdt.h>
#include <math.h>
#include <stdlib.h>
#include "param.h"
#include "global.h"
#include "tft.h"
#include "uart.h"

#define XTAL_CPU			20000000
#define UART_BAUD_RATE		   19200 

unsigned char xpos, ypos,textfg=WHITE,textbg=BLACK;

int main(void)
{	unsigned char c,i;
	PORTD=255;
	tft_init();								//TV Generator mit Speicherinterface, Timer1 und Ports initialisieren
	uart_init(UART_BAUD_SELECT(UART_BAUD_RATE, XTAL_CPU));
	
	tft_writestringP( 5, 2,RED,BLACK,PSTR("4\"TFT"));	//"

	tft_writestringP( 1, 3,BLUE,YELLOW,PSTR("Text auf farbigem"));
	tft_writestringP( 1, 4,BLUE,YELLOW,PSTR("Hintergrund"));

	tft_writestringP( 2, 6,RED,BLACK,PSTR("RED"));
	tft_writestringP( 2, 7,BLACK,RED,PSTR("RED"));

	tft_writestringP( 5, 6,GREEN,BLACK,PSTR("GREEN"));
	tft_writestringP( 5, 7,BLACK,GREEN,PSTR("GREEN"));

	tft_writestringP(10, 6,BLUE,BLACK,PSTR("BLUE"));
	tft_writestringP(10, 7,BLACK,BLUE,PSTR("BLUE"));

	tft_writestringP(14, 6,WHITE,BLACK,PSTR("WHITE"));
	tft_writestringP(14, 7,BLACK,WHITE,PSTR("WHITE"));

	tft_writestringP( 2, 9,CYAN,BLACK,PSTR("CYAN"));
	tft_writestringP( 2,10,BLACK,CYAN,PSTR("CYAN"));

	tft_writestringP( 6, 9,MAGENTA,BLACK,PSTR("MAGENTA"));
	tft_writestringP( 6,10,BLACK,MAGENTA,PSTR("MAGENTA"));

	tft_writestringP(13, 9,YELLOW,BLACK,PSTR("YELLOW"));
	tft_writestringP(13,10,BLACK,YELLOW,PSTR("YELLOW"));


	c=48;
	for (i=0; i<76; i++)
		tft_writechar(1+i%19,14+i/19,MAGENTA,GREEN,c++);

	for (i=0; i<20; i++)
		tft_writechar(i,0,WHITE,BLACK,i%10+48);

	for (i=0; i<22; i++)
		tft_writechar(0,i,WHITE,BLACK,i%10+48);

	for (;;);
	{	c = uart_getchar();
		if (c>=32)						//Display Text
		{	tft_writechar(xpos,ypos,textfg,textbg,c);
			xpos++;
			if (xpos>=XSize)
			{	xpos=0;
				ypos++;
				if (ypos>=YSize)
					ypos=0;
			}
		}
		else if (c==1)			//Cursor Home
		{	xpos=0;
			ypos=0;
		}
		else if (c==5)			//Set Foreground Color (Color Value)
		{	textfg=uart_getchar();
		}
		else if (c==7)			//Set Background Color (Color Value)
		{	textbg=uart_getchar();	
		}
		else if (c==8)			//Backspace
		{	xpos--;
			if (xpos>128)
			{	xpos=XSize-1;
				ypos--;
				if (ypos>128)
					ypos=YSize-1;	
			}
			tft_writechar(xpos,ypos,textfg,textbg,32);
		}
		else if (c==10)        //Line Feed
		{	ypos++;
			if (ypos>=YSize) 
				ypos=0;
		}
		else if (c==11)        //Delete in place
		{	tft_writechar(xpos,ypos,textfg,textbg,32);
		}
		else if (c==12)        //Form Feed
		{	tft_clear();
		}
		else if (c==13)			//Carriage Return
		{	xpos=0;
		}
		else if (c==17)        //Set Cursor Position (Column and Row)
		{	xpos=uart_getchar();
			ypos=uart_getchar();
		}
	}
}


