#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/wdt.h>
#include "param.h"
#include "global.h"
#include "tft.h"
#include "font_8x12.c"

#ifdef CONFIG1
#ifdef CONFIG2
#error "Define one configuration!"
#endif
#endif
#ifndef CONFIG1
#ifndef CONFIG2
#error "No configuration defined!"
#endif
#endif


unsigned char txtram[YSize][XSize][2];

void tft_init(void)
{	cli();
#ifdef CONFIG1
	DDRB|=12;
	DDRB&=~16;
	DDRC=255;
	ICR1 =PIXLINE-1;			// Bildbreite
	OCR1B=SyncWidth;
	OCR1A=XStart-74;			// etwa 76 ist maximum fr idle
	TCCR1A=(1<<COM1B1)|(1<<COM1B0)|(1<<WGM11);
	TCCR1B=(1<<WGM12)|(1<<WGM13)|1;

	TIMSK1=(1<<OCIE1A);
	TIFR1=(1<<OCF1A);
#endif


#ifdef CONFIG2
	DDRB|=10;
	DDRB&=~4;
	DDRC=255;
	ICR1 =PIXLINE-1;			// Bildbreite
	OCR1A=SyncWidth;			// etwa 76 ist maximum fr idle
	OCR1B=XStart-74;
	TCCR1A=(1<<COM1A1)|(1<<COM1A0)|(1<<WGM11);
	TCCR1B=(1<<WGM12)|(1<<WGM13)|1;

	TIMSK=(1<<OCIE1B);
	TIFR=(1<<OCF1B);
#endif
	sei();
}

void tft_writestring(unsigned char x, unsigned char y, unsigned char textfarbe, unsigned char hintergrundfarbe, char *txt)
{
	while (*txt)
		tft_writechar (x++, y, textfarbe, hintergrundfarbe, *txt++);
}

void tft_writestringP(unsigned char x, unsigned char y, unsigned char textfarbe, unsigned char hintergrundfarbe, prog_char *txt)
{	unsigned char c;
	while ((c=pgm_read_byte(txt++)))
		tft_writechar (x++, y, textfarbe, hintergrundfarbe, c);
}

void tft_writechar (unsigned char x, unsigned char y, unsigned char textfarbe, unsigned char hintergrundfarbe, char zeichen)
{	if ((x>=XSize)||(y>=YSize))
		return;
	txtram[y][x][0]=zeichen;
	txtram[y][x][1]=(textfarbe&15)|(hintergrundfarbe*16);
}

void tft_clear(void)
{	unsigned char x=0,y=0;
	y=YSize;
	x=XSize;
	while (--y)
	{	while (--x)
		{	txtram[y][x][0]=0;
			txtram[y][x][1]=0;
		}
	}
}


